const AbstractInstance = require("./abstractInstance")

class Instance extends AbstractInstance {
	constructor(db) {
		super(db)
		this.updates = {
			1: () => this.db.run(`
create table if not exists users (
	discordId text not null primary key,
	messageCount int
)
				`)
		}
	}

	gets() {
		return this.db.all("select * from users")
	}

	get(discordId) {
		return this.db.get(`select * from users where discordId = ?`, discordId)
	}

        update(discordUser, update) {
                return this.db.run(`update users set ${this.getUpdateString(update)} where discordId=$discordId`, {...update, ...{["$discordId"]: discordUser.id}})
        }

	create(discordUser) {
		return this.db.run(`insert into users(discordId, messageCount) values (?, 0)`, discordUser.id)
	}
}

module.exports = Instance
